import java.util.HashSet;

/**
 * Class for representing a binary image (as a 2D boolean array)
 */
class BinaryImage {
  public static final boolean WHITE = false;
  public static final boolean BLACK = true;

  /** 2D array representing the image pixels */
  final boolean[][] pixels;

  /**
   * Create an image of n rows and m columns
   * 
   * @param n
   * @param m
   */
  BinaryImage(int n, int m) {
    assert n >= 1 && m >= 1;
    this.pixels = new boolean[n][m];
  }

  /**
   * Set the pixel BLACK
   * 
   * @param i
   * @param j
   */
  void set(int i, int j) {
    if (i >= 0 && i < pixels.length && j >= 0 && j < pixels[0].length)
      this.pixels[i][j] = BLACK;
  }

  /**
   * Set the pixel WHITE
   * 
   * @param i
   * @param j
   */
  void clear(int i, int j) {
    if (i >= 0 && i < pixels.length && j >= 0 && j < pixels[0].length)
      this.pixels[i][j] = WHITE;
  }

  /**
   * Inverse the color of a pixel
   */
  public void inversePixel(int i, int j) {
    if (i >= 0 && i < pixels.length && j >= 0 && j < pixels[0].length)
      this.pixels[i][j] = !this.pixels[i][j];
  }

  @Override
  public int hashCode() {
    throw new Error("\nMéthode int hashCode() à compléter (Q1.2)\nMethod int hashCode() to be completed (Q1.2)");
  }

  /**
   * Check equality between two images (pixel by pixel)
   */
  @Override
  public boolean equals(Object o) {
    BinaryImage that = (BinaryImage) o;
    throw new Error("\nMéthode boolean equals(Object o) à compléter (Q1.1)\nMethod boolean equals(Object o) to be completed (Q1.1)");
  }

  /**
   * Given a collection of binary images (stored in the input array), remove all
   * duplicates and return a new array storing the images (without duplicates)
   * 
   * @param a an array storing the input images
   * @return a new array storing all input images without repetitions
   */
  static BinaryImage[] deleteDuplicates(BinaryImage[] t) {
    throw new Error("\nMéthode BinaryImage[] deleteDuplicates(BinaryImage[] a) à compléter (Question 1.2)\\n" + //
        "Method BinaryImage[] deleteDuplicates(BinaryImage[] a) to be completed (Question 1.2)");
  }

}
