public class Test31 {

	public static void main(String[] args) {
		if (!Test31.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("To run the tests please activate the -ea option of the JVM");
			System.exit(1);
		}

		System.out.println("(Q3.1) Precalcul des distances à la racine: Test de setDistances()");

		Tree t; // input tree

		System.out.print("\t Teste arbre de hauteur 1 (les 3 fils de la racine sont B, C, D) ...");
		t=Test21.createTinyTree();
		checkDistanceArray(t);
		
		System.out.println("\t\t [OK].");

		System.out.print("\t Teste l'arbre de l'exemple fourni dans le sujet (12 noeuds) ...");
		t=Test21.createT2();
		checkDistanceArray(t);

		System.out.println("\t\t [OK].");
	}

	public static void checkDistanceArray(Tree t) {
		int size=Tree.size(t); // tree size
		int expectedSize=2*size-1; // expected size of the distance array: 2n-1

		//GT.print(t);
		int b=4;
		EfficientLCA lca=new EfficientLCA(t, b);
		
		int n=Tree.size(t);
		Integer rootIndex=lca.indices.get(lca.node.element); // indice du noeud racine dans le array dist[]: il est censé etre 0

		assert(lca.dist!=null): "\nLe tableau dist[] n'est pas initialisé";
		assert (expectedSize==lca.dist.length): "\nLe tableau dist[] devrait avoir taille "+size+", au lieu de "+lca.dist.length;
		assert(lca.indices.size()==n): "\nLe nombre d'entrées dans la table 'indices' est "+lca.indices.size()+", alors qu'il devrait etre "+n;
		assert(rootIndex!=null): "\nL'indice de la racine n'est pas défini";
		assert(rootIndex.intValue()==0): "\nLa racine "+lca.node.element+" est censée avoir indice "+0;

		int count=0;
		for(Data data: lca.dist) {
			assert (data!=null): "\nL'entrée d'indice "+count+" dans le tableau T n'est pas définie";
			int distance=data.val;
			assert (distance<=size-1): "\nLe noeud "+data+" devrait etre à distance au plus "+(size-1)+" de la racine, au lieu de "+distance;
			count++;
		}

		int rootDegree=t.children.size(); // degree of the root node
		int countRoot=0;
		//Data.printArray(lca.dist);
		for(Data data: lca.dist) {
			if(data.s.equals(t.element)) {	
				countRoot++;
			}
		}
		assert (countRoot==rootDegree+1): "\nLe noeud racine apparait "+(countRoot)+" fois, alors qu'il devrait apparaitre "+(rootDegree+1);

		int rootValue=lca.dist[0].val; // distance from the root to the root (expected to be 0)
		assert (rootValue==0): "\nLa racine devrait etre à distance "+0+", au lieu de "+rootValue;
		if(size>1) {
			int firstChild=lca.dist[1].val; // distance from the first child to the root (expected to be 1)
			assert (firstChild==1): "\nLe noeud "+lca.dist[1]+" devrait etre à distance "+1+", au lieu de "+firstChild;
		}

		// check the last two elements in the distance array
		rootValue=lca.dist[lca.dist.length-1].val; // the last element correspond to the last occurrence of the root (distance 0)
		assert (rootValue==0): "\nLa dernière occurrence de la racine devrait etre à distance "+0+", au lieu de "+rootValue;
		if(size>1) {
			int lastChild=lca.dist[lca.dist.length-2].val; // distance from the last child to the root (expected to be 1)
			assert (lastChild==1): "\nLe noeud "+lca.dist[lca.dist.length-2]+" devrait etre à distance "+1+", au lieu de "+lastChild;
		}
	}

}
